

MobAI = {}	-- {AI

function MobAI.new( extends )
	if extends then
		setmetatable( extends, { __index = MobAI } )	-- MobAI -> extends -> {} ̏Ń^e[up
		return setmetatable( {}, { __index = extends } )
	else
		return setmetatable( {}, { __index = MobAI } )
	end
end

MobAI.motiontable = {}
MobAI.motiontable[ MOTION_STAND ] = "OnMOTION_STAND"
MobAI.motiontable[ MOTION_MOVE ] = "OnMOTION_MOVE"
MobAI.motiontable[ MOTION_ATTACK ] = "OnMOTION_ATTACK"
MobAI.motiontable[ MOTION_ATTACK2 ] = "OnMOTION_ATTACK2"

function MobAI:motion( map, obj )
	local name = self.motiontable[ obj.motion ]
	if self[ name ] then
		print("call motion:", name )
		self[ name ]( map, obj )
	end
end

function NextRelay( n, dest )
	if math.abs( dest - n ) <= 3 then
		return dest
	end
	if dest - n > 0 then
		return math.min( dest, n + 3 )	-- 3
	else
		return math.max( dest, n - 3 )
	end
end

function MobAI.OnMOTION_MOVE( map, obj )
	-- Ƃ肠1t[ŖړIʒuɓBݒ
	local x = obj.x	-- ʒuۑ
	local y = obj.y
	map:eraseObject( obj.id )
	map:insertObject( obj, NextRelay( x, obj.destx ), NextRelay( y, obj.desty ) )
	if obj.x == obj.destx and obj.y == obj.desty then	-- ړIʒuɒBꍇ
		obj.motion = MOTION_STAND		-- Ԃɖ߂
		obj.destx = 0
		obj.desty = 0
	end
	if map:isActor( obj.targetid ) then	-- ^QĂ鎞
		TryAttack( obj )
	end
end

function MobAI.OnMOTION_ATTACK2( map, obj )
	assert( map:isValidObjectId( obj.targetid ) )
	obj.motion = MOTION_ATTACK -- MOTION_ATTACK
end

function Damage( target, dmg )
	target.HP = target.HP - dmg
	if target.HP <= 0 then
		target.HP = 0
		target.motion = MOTION_DEAD
	end
end

function MobAI.OnMOTION_ATTACK( map, obj )
	assert( map:isValidObjectId( obj.targetid ) )
	assert( obj.ATK )
	-- _[W^
	local target = map:getObject( obj.targetid )
	local hp = target.HP
	Damage( target, obj.ATK )
	print( string.format("attack: %d -> %d  HP %d -> %d", obj.id, target.id, hp, target.HP ) )
	
	if target.motion == MOTION_DEAD then
		obj.targetid = -1
		obj.motion = MOTION_STAND
	else
		map:moveToSight( obj.id, obj.targetid, obj.atkrange or 1 )	-- xʒumF
	end
end

MobAI.Homunclus = {}

function MobAI.Homunclus:motion( map, obj )
	MobAI:motion( map, obj )
	if obj.motion == MOTION_STAND then	-- sҋ@̂
		AI( obj.id )	-- [VɎ̍s߂
	--	MobAI:motion( map, obj )	-- x
	end
end

MobAI.Active = {}

function MobAI.Active.OnMOTION_STAND( map, obj )
	local enemyid = map:getNearestEnemy( obj.id )
	if map:isValidObjectId( enemyid ) then
		obj.targetid = enemyid
		map:moveToSight( obj.id, obj.targetid, obj.atkrange )
	end
end

MobAI.Nonactive = {}

